# Wat moet er gebeuren bij het starten van de simulatie?
onstart{
  $fill = 1
  compoortopties = ["Seriele poort:", "Baudrate:"]
  # Standaard waarden!, deze kun je zelf aanpassen!
  standaard = ["COM8", "9600"]
  # Lijst met baudrates voor de dropdownlijst in het menu.
  baudratelijst = ["", "4800|9600|14400|19200|28800|38400|57600|115200"]
  # Geef het dialoogvenster weer voor vraag naar gegevens.
  serialsettings = UI.inputbox(compoortopties, standaard, baudratelijst, "Seriele poort instellingen:")
 
  if serialsettings != FALSE
    # Haal de instellingen uit het diagloogvenster en koppel deze aan een variabele.
    $comport = serialsettings[0]
    $baudrate = serialsettings[1].to_i
 
    begin
      # Open de seriele poort.
      @serial = Serial.new($comport, $baudrate)
    rescue RubySerial::Exception => e
      # Sluit de seriele poort als deze open staat.
      @serial.close if @serial
      # Reset/stop de simulatie.
      MSketchyPhysics3::SketchyPhysicsClient.physicsReset
      # Geef een bericht dat de seriele poort niet is gevonden.
      UI.messagebox("Seriele poort niet gevonden!")
    end
  else
    # Reset/stop de simulatie.
    MSketchyPhysics3::SketchyPhysicsClient.physicsReset
  end
}
onclick{
  # Verander het object van kleur.
  @m = Sketchup.active_model.materials.add "My material"
  group.material = @m
  # Verander de kleur van het object naar geel.
  @m.color="Yellow"
  logLine("COM poort: " + $comport.to_s)
  logLine("BAUD rate: " + $baudrate.to_s)
  logLine("")
  logLine("Seriele data: 1")
  logLine("LED status: AAN")
  logLine("")
  logLine("")
  logLine("")
  logLine("")
  logLine("")
  @serial.write('1')
}

onunclick{
  # Verander het object van kleur.
  @m = Sketchup.active_model.materials.add "My material"
  group.material = @m
  # Verander de kleur van het object naar wit.
  @m.color="White"
  logLine("COM poort: " + $comport.to_s)
  logLine("BAUD rate: " + $baudrate.to_s)
  logLine("")
  logLine("Seriele data: 0")
  logLine("LED status: UIT")
  logLine("")
  logLine("")
  logLine("")
  logLine("")
  logLine("")
  @serial.write('0')
}

onUpdate {
# Sluit het 'control panel' venster bij het starten van de simulatie.
MSketchyPhysics3.closeControlPanel if frame == 1
}

# Wat moet er gebeuren als de de simulatie stopt?
onend{
  # Sluit de seriele poort als deze open staat.
  @serial.close if @serial
}